// python wrapper for vtkSimilarityBalls
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSimilarityBalls.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSimilarityBalls(PyObject *dict); }
extern "C" { PyObject *PyvtkSimilarityBalls_ClassNew(); }


static PyObject *
PyvtkSimilarityBalls_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSimilarityBalls::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSimilarityBalls_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimilarityBalls *op = static_cast<vtkSimilarityBalls *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSimilarityBalls::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSimilarityBalls_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSimilarityBalls *tempr = vtkSimilarityBalls::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSimilarityBalls_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimilarityBalls *op = static_cast<vtkSimilarityBalls *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkSimilarityBalls *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSimilarityBalls::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSimilarityBalls_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkSimilarityBalls::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSimilarityBalls_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimilarityBalls *op = static_cast<vtkSimilarityBalls *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkSimilarityBalls::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSimilarityBalls_SetSimilarityData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSimilarityData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimilarityBalls *op = static_cast<vtkSimilarityBalls *>(vp);

  vtkDataObject *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataObject"))
  {
    if (ap.IsBound())
    {
      op->SetSimilarityData(temp0);
    }
    else
    {
      op->vtkSimilarityBalls::SetSimilarityData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSimilarityBalls_SetSimilarityConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSimilarityConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimilarityBalls *op = static_cast<vtkSimilarityBalls *>(vp);

  vtkAlgorithmOutput *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAlgorithmOutput"))
  {
    if (ap.IsBound())
    {
      op->SetSimilarityConnection(temp0);
    }
    else
    {
      op->vtkSimilarityBalls::SetSimilarityConnection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSimilarityBalls_SetGridData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGridData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimilarityBalls *op = static_cast<vtkSimilarityBalls *>(vp);

  vtkDataObject *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataObject"))
  {
    if (ap.IsBound())
    {
      op->SetGridData(temp0);
    }
    else
    {
      op->vtkSimilarityBalls::SetGridData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSimilarityBalls_SetGridConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGridConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimilarityBalls *op = static_cast<vtkSimilarityBalls *>(vp);

  vtkAlgorithmOutput *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAlgorithmOutput"))
  {
    if (ap.IsBound())
    {
      op->SetGridConnection(temp0);
    }
    else
    {
      op->vtkSimilarityBalls::SetGridConnection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSimilarityBalls_SetKindOfMaxima(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetKindOfMaxima");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimilarityBalls *op = static_cast<vtkSimilarityBalls *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetKindOfMaxima(temp0);
    }
    else
    {
      op->vtkSimilarityBalls::SetKindOfMaxima(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSimilarityBalls_GetKindOfMaxima(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetKindOfMaxima");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimilarityBalls *op = static_cast<vtkSimilarityBalls *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetKindOfMaxima() :
      op->vtkSimilarityBalls::GetKindOfMaxima());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSimilarityBalls_SetProduceBalls(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetProduceBalls");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimilarityBalls *op = static_cast<vtkSimilarityBalls *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetProduceBalls(temp0);
    }
    else
    {
      op->vtkSimilarityBalls::SetProduceBalls(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSimilarityBalls_GetProduceBalls(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProduceBalls");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimilarityBalls *op = static_cast<vtkSimilarityBalls *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetProduceBalls() :
      op->vtkSimilarityBalls::GetProduceBalls());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSimilarityBalls_Methods[] = {
  {"IsTypeOf", PyvtkSimilarityBalls_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkSimilarityBalls_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkSimilarityBalls_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkSimilarityBalls\nC++: static vtkSimilarityBalls *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSimilarityBalls_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkSimilarityBalls\nC++: vtkSimilarityBalls *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkSimilarityBalls_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkSimilarityBalls_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetSimilarityData", PyvtkSimilarityBalls_SetSimilarityData, METH_VARARGS,
   "SetSimilarityData(self, input:vtkDataObject) -> None\nC++: void SetSimilarityData(vtkDataObject *input)\n\nstandard pipeline input for port 1 This is the similarity data as\nproduced by vtkMomentInvariants.\n"},
  {"SetSimilarityConnection", PyvtkSimilarityBalls_SetSimilarityConnection, METH_VARARGS,
   "SetSimilarityConnection(self, algOutput:vtkAlgorithmOutput)\n    -> None\nC++: void SetSimilarityConnection(vtkAlgorithmOutput *algOutput)\n\nstandard pipeline input for port 1 This is the similarity data as\nproduced by vtkMomentInvariants.\n"},
  {"SetGridData", PyvtkSimilarityBalls_SetGridData, METH_VARARGS,
   "SetGridData(self, input:vtkDataObject) -> None\nC++: void SetGridData(vtkDataObject *input)\n\nstandard pipeline input for port 1 This vtkImageData input steers\nthe resolution of the balls. It is helpful if its extent is a\nmultiple of the first input's. Then, the circles are centered\nnicely.\n"},
  {"SetGridConnection", PyvtkSimilarityBalls_SetGridConnection, METH_VARARGS,
   "SetGridConnection(self, algOutput:vtkAlgorithmOutput) -> None\nC++: void SetGridConnection(vtkAlgorithmOutput *algOutput)\n\nstandard pipeline input for port 1 This vtkImageData input steers\nthe resolution of the balls. It is helpful if its extent is a\nmultiple of the first input's. Then, the circles are centered\nnicely.\n"},
  {"SetKindOfMaxima", PyvtkSimilarityBalls_SetKindOfMaxima, METH_VARARGS,
   "SetKindOfMaxima(self, _arg:int) -> None\nC++: virtual void SetKindOfMaxima(int _arg)\n\nSet/Get the maximal order up to which the moments are computed.\n"},
  {"GetKindOfMaxima", PyvtkSimilarityBalls_GetKindOfMaxima, METH_VARARGS,
   "GetKindOfMaxima(self) -> int\nC++: virtual int GetKindOfMaxima()\n\n"},
  {"SetProduceBalls", PyvtkSimilarityBalls_SetProduceBalls, METH_VARARGS,
   "SetProduceBalls(self, _arg:bool) -> None\nC++: virtual void SetProduceBalls(bool _arg)\n\nSet/Get the maximal order up to which the moments are computed.\n"},
  {"GetProduceBalls", PyvtkSimilarityBalls_GetProduceBalls, METH_VARARGS,
   "GetProduceBalls(self) -> bool\nC++: virtual bool GetProduceBalls()\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkSimilarityBalls_Doc =
  "vtkSimilarityBalls - compute the local maxima in the similarity field\nand draw a circle of radius around it\n\n"
  "Superclass: vtkDataSetAlgorithm\n\n"
  "vtkSimilarityBalls is a filter that takes the similarityData as\n"
  "produced by vtkMomentInvariants.\n"
  "0. It computes the local maxima in space plus scale and produces the\n"
  "   output localMaxSimilarity that contains the similarity value\n"
  "   together with the corresponding radius at the maxima. All other\n"
  "   points are zero. If a grid is provided in the optional second\n"
  "   input, it also produces two output fields for further\n"
  "   visualization that encode the radius through drawing\n"
  "1. a solid ball or\n"
  "2. a hollow sphere around those places. The second input steers the\n"
  "   resolution of the balls. It is helpful if its extent is a multiple\n"
  "of the first input's. Then, the circles are centered nicely. The\n"
  "   spheres/circles are good for 2D visualization The balls are good\n"
  "   for 3D volume rendering or steering seeding of visualization\n"
  "   elements The theory and the algorithm is described in Roxana\n"
  "   Bujack, Jens Kasten, Ingrid Hotz, Gerik Scheuermann, and Eckhard\n"
  "   Hitzer: \"Moment Invariants for 2D Flow Fields via Normalization in\n"
  "Detail.\"\n"
  "   http://www.informatik.uni-leipzig.de/~bujack/bujackTVCGSmall.pdf@pa\n"
  "   r Thanks: Developed by Roxana Bujack and Karen Tsai at Los Alamos\n"
  "   National Laboratory.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkSimilarityBalls_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MomentInvariants.vtkSimilarityBalls", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkSimilarityBalls_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSimilarityBalls_StaticNew()
{
  return vtkSimilarityBalls::New();
}

PyObject *PyvtkSimilarityBalls_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkSimilarityBalls_Type, PyvtkSimilarityBalls_Methods,
    "vtkSimilarityBalls",
 &PyvtkSimilarityBalls_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkDataSetAlgorithm");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkSimilarityBalls(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSimilarityBalls_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSimilarityBalls", o) != 0)
  {
    Py_DECREF(o);
  }

}

