// python wrapper for vtkDICOMVR
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMVR.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMVR(PyObject *dict); }
#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMVR_EnumType_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMVR.EnumType", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkDICOMVR_EnumType_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkDICOMVR_EnumType_Type, static_cast<int>(val));
}


static PyObject *
PyvtkDICOMVR_IsValid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsValid");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMVR *op = static_cast<vtkDICOMVR *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsValid();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMVR_GetType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetType");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMVR *op = static_cast<vtkDICOMVR *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetType();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMVR_GetText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetText");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMVR *op = static_cast<vtkDICOMVR *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = op->GetText();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMVR_HasLongVL(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasLongVL");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMVR *op = static_cast<vtkDICOMVR *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->HasLongVL();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMVR_HasSpecificCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasSpecificCharacterSet");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMVR *op = static_cast<vtkDICOMVR *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->HasSpecificCharacterSet();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMVR_HasTextValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasTextValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMVR *op = static_cast<vtkDICOMVR *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->HasTextValue();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMVR_HasNumericValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasNumericValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMVR *op = static_cast<vtkDICOMVR *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->HasNumericValue();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMVR_HasSingleValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasSingleValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMVR *op = static_cast<vtkDICOMVR *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->HasSingleValue();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMVR_Methods[] = {
  {"IsValid", PyvtkDICOMVR_IsValid, METH_VARARGS,
   "IsValid(self) -> bool\nC++: bool IsValid()\n\nCheck validity of this VR.\n"},
  {"GetType", PyvtkDICOMVR_GetType, METH_VARARGS,
   "GetType(self) -> int\nC++: int GetType()\n\nGet the data type for this VR.\n"},
  {"GetText", PyvtkDICOMVR_GetText, METH_VARARGS,
   "GetText(self) -> str\nC++: const char *GetText()\n\nGet the two-character text for this VR.\n"},
  {"HasLongVL", PyvtkDICOMVR_HasLongVL, METH_VARARGS,
   "HasLongVL(self) -> bool\nC++: bool HasLongVL()\n\nThe VRs OB, OD, OF, OL, OW, OV, SQ, UC, UN, UR, UT require a\n32-bit VL.\n"},
  {"HasSpecificCharacterSet", PyvtkDICOMVR_HasSpecificCharacterSet, METH_VARARGS,
   "HasSpecificCharacterSet(self) -> bool\nC++: bool HasSpecificCharacterSet()\n\nThe VRs SH, LO, PN, ST, LT, UC, and UT use SpecificCharacterSet.\n"},
  {"HasTextValue", PyvtkDICOMVR_HasTextValue, METH_VARARGS,
   "HasTextValue(self) -> bool\nC++: bool HasTextValue()\n\nThis is true for all VRs whose value is stored as text.\n"},
  {"HasNumericValue", PyvtkDICOMVR_HasNumericValue, METH_VARARGS,
   "HasNumericValue(self) -> bool\nC++: bool HasNumericValue()\n\nThis is true for for all VRs that store numbers.\n\nThe VRs included are IS, DS, US, UL, UV, SS, SL, SV, FL, FD.  The\nVRs OB, OW, OL, OV, OF, and OD are not included.\n"},
  {"HasSingleValue", PyvtkDICOMVR_HasSingleValue, METH_VARARGS,
   "HasSingleValue(self) -> bool\nC++: bool HasSingleValue()\n\nThe VRs ST, LT, and UT carry only one value.\n\nSpecifically, this means that a backslash is not interpreted as a\nvalue separator in these VRs. UR is not included, because\nbackslash is an illegal character in UR.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMVR_vtkDICOMVR_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMVR");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMVR *op = new vtkDICOMVR();

    result = PyVTKSpecialObject_New("vtkDICOMVR", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMVR_vtkDICOMVR_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMVR");

  typedef vtkDICOMVR::EnumType temp0_type;
  temp0_type temp0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetEnumValue(temp0, "vtkDICOMVR.EnumType"))
  {
    vtkDICOMVR *op = new vtkDICOMVR(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMVR", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMVR_vtkDICOMVR_s3(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMVR");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMVR *op = new vtkDICOMVR(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMVR", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMVR_vtkDICOMVR_s4(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMVR");

  const size_t size0 = 2;
  unsigned char temp0[2];
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkDICOMVR *op = new vtkDICOMVR(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMVR", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMVR_vtkDICOMVR_s5(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMVR");

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR"))
  {
    vtkDICOMVR *op = new vtkDICOMVR(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMVR", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMVR_vtkDICOMVR_Methods[] = {
  {"vtkDICOMVR", PyvtkDICOMVR_vtkDICOMVR_s2, METH_VARARGS,
   "@E vtkDICOMVR.EnumType"},
  {"vtkDICOMVR", PyvtkDICOMVR_vtkDICOMVR_s3, METH_VARARGS,
   "@z"},
  {"vtkDICOMVR", PyvtkDICOMVR_vtkDICOMVR_s4, METH_VARARGS,
   "@P *B"},
  {"vtkDICOMVR", PyvtkDICOMVR_vtkDICOMVR_s5, METH_VARARGS,
   "@W vtkDICOMVR"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMVR_vtkDICOMVR(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMVR_vtkDICOMVR_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMVR_vtkDICOMVR_s1(self, args);
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMVR");
  return nullptr;
}


static const char *PyvtkDICOMVR_Doc =

  "vtkDICOMVR() -> vtkDICOMVR\nC++: vtkDICOMVR()\nvtkDICOMVR(vr:EnumType) -> vtkDICOMVR\nC++: vtkDICOMVR(EnumType vr)\nvtkDICOMVR(vr:str) -> vtkDICOMVR\nC++: vtkDICOMVR(const char *vr)\nvtkDICOMVR(vr:(int, int)) -> vtkDICOMVR\nC++: vtkDICOMVR(const unsigned char vr[2])\nvtkDICOMVR(__a:vtkDICOMVR) -> vtkDICOMVR\nC++: vtkDICOMVR(const &vtkDICOMVR)\n""\n"
  "vtkDICOMVR - VRs (Value Representations)\n\n"
;

static PyObject *
PyvtkDICOMVR_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMVR_vtkDICOMVR(nullptr, args);
}

static void PyvtkDICOMVR_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMVR *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static PyObject *PyvtkDICOMVR_String(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  std::ostringstream os;
  if (obj->vtk_ptr)
  {
    os << *static_cast<const vtkDICOMVR *>(obj->vtk_ptr);
  }
  const std::string &s = os.str();
  return PyUnicode_FromStringAndSize(s.data(), s.size());
}

static int PyvtkDICOMVR_CheckExact(PyObject *ob);

static PyObject *PyvtkDICOMVR_RichCompare(
  PyObject *o1, PyObject *o2, int opid)
{
  PyObject *n1 = nullptr;
  PyObject *n2 = nullptr;
  const vtkDICOMVR *so1 = nullptr;
  const vtkDICOMVR *so2 = nullptr;
  int result = -1;

  if (PyvtkDICOMVR_CheckExact(o1))
  {
    PyVTKSpecialObject *s1 = (PyVTKSpecialObject *)o1;
    so1 = static_cast<const vtkDICOMVR *>(s1->vtk_ptr);
  }
  else
  {
    so1 = static_cast<const vtkDICOMVR *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o1, "vtkDICOMVR", &n1));
    if (so1 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  if (PyvtkDICOMVR_CheckExact(o2))
  {
    PyVTKSpecialObject *s2 = (PyVTKSpecialObject *)o2;
    so2 = static_cast<const vtkDICOMVR *>(s2->vtk_ptr);
  }
  else
  {
    so2 = static_cast<const vtkDICOMVR *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o2, "vtkDICOMVR", &n2));
    if (so2 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  switch (opid)
  {
    case Py_LT:
      result = ((*so1) < (*so2));
      break;
    case Py_LE:
      result = ((*so1) <= (*so2));
      break;
    case Py_EQ:
      result = ((*so1) == (*so2));
      break;
    case Py_NE:
      result = ((*so1) != (*so2));
      break;
    case Py_GT:
      result = ((*so1) > (*so2));
      break;
    case Py_GE:
      result = ((*so1) >= (*so2));
      break;
  }

  if (n1)
  {
    Py_DECREF(n1);
  }
  else if (n2)
  {
    Py_DECREF(n2);
  }

  if (result == -1)
  {
    PyErr_SetString(PyExc_TypeError, "operation not available");
    return nullptr;
  }

  // avoids aliasing issues with Py_INCREF(Py_False)
  return PyBool_FromLong((long)result);
}

static Py_hash_t PyvtkDICOMVR_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMVR_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMVR", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMVR_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMVR_Hash, // tp_hash
  nullptr, // tp_call
  PyvtkDICOMVR_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMVR_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  PyvtkDICOMVR_RichCompare, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMVR_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static int PyvtkDICOMVR_CheckExact(PyObject *ob)
{
  return (Py_TYPE(ob) == &PyvtkDICOMVR_Type);
}

static void *PyvtkDICOMVR_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMVR(*static_cast<const vtkDICOMVR*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMVR_TypeNew
extern "C" { PyObject *PyvtkDICOMVR_TypeNew(); }
#define DECLARED_PyvtkDICOMVR_TypeNew
#endif

PyObject *PyvtkDICOMVR_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMVR_Type,
    PyvtkDICOMVR_Methods,
    PyvtkDICOMVR_vtkDICOMVR_Methods,
    &PyvtkDICOMVR_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkDICOMVR_EnumType_Type);
  PyVTKEnum_Add(&PyvtkDICOMVR_EnumType_Type, "vtkDICOMVR.EnumType");

  o = (PyObject *)&PyvtkDICOMVR_EnumType_Type;
  if (PyDict_SetItemString(d, "EnumType", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 37; c++)
  {
    typedef vtkDICOMVR::EnumType cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[37] = {
        { "XX", vtkDICOMVR::XX },
        { "AE", vtkDICOMVR::AE },
        { "AS", vtkDICOMVR::AS },
        { "AT", vtkDICOMVR::AT },
        { "CS", vtkDICOMVR::CS },
        { "DA", vtkDICOMVR::DA },
        { "DS", vtkDICOMVR::DS },
        { "DT", vtkDICOMVR::DT },
        { "FD", vtkDICOMVR::FD },
        { "FL", vtkDICOMVR::FL },
        { "IS", vtkDICOMVR::IS },
        { "LO", vtkDICOMVR::LO },
        { "LT", vtkDICOMVR::LT },
        { "OB", vtkDICOMVR::OB },
        { "OD", vtkDICOMVR::OD },
        { "OF", vtkDICOMVR::OF },
        { "OL", vtkDICOMVR::OL },
        { "OW", vtkDICOMVR::OW },
        { "PN", vtkDICOMVR::PN },
        { "SH", vtkDICOMVR::SH },
        { "SL", vtkDICOMVR::SL },
        { "SQ", vtkDICOMVR::SQ },
        { "SS", vtkDICOMVR::SS },
        { "ST", vtkDICOMVR::ST },
        { "TM", vtkDICOMVR::TM },
        { "UC", vtkDICOMVR::UC },
        { "UI", vtkDICOMVR::UI },
        { "UL", vtkDICOMVR::UL },
        { "UN", vtkDICOMVR::UN },
        { "UR", vtkDICOMVR::UR },
        { "US", vtkDICOMVR::US },
        { "UT", vtkDICOMVR::UT },
        { "OX", vtkDICOMVR::OX },
        { "XS", vtkDICOMVR::XS },
        { "OV", vtkDICOMVR::OV },
        { "SV", vtkDICOMVR::SV },
        { "UV", vtkDICOMVR::UV },
      };

    o = PyvtkDICOMVR_EnumType_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMVR(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMVR_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMVR", o) != 0)
  {
    Py_DECREF(o);
  }

}

