// python wrapper for vtkNIFTIHeader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkNIFTIHeader.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkNIFTIHeader(PyObject *dict); }
extern "C" { PyObject *PyvtkNIFTIHeader_ClassNew(); }

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkNIFTIHeader_IntentCodeEnum_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkNIFTIHeader.IntentCodeEnum", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkNIFTIHeader_IntentCodeEnum_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkNIFTIHeader_IntentCodeEnum_Type, static_cast<int>(val));
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkNIFTIHeader_XFormCodeEnum_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkNIFTIHeader.XFormCodeEnum", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkNIFTIHeader_XFormCodeEnum_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkNIFTIHeader_XFormCodeEnum_Type, static_cast<int>(val));
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkNIFTIHeader_SliceCodeEnum_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkNIFTIHeader.SliceCodeEnum", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkNIFTIHeader_SliceCodeEnum_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkNIFTIHeader_SliceCodeEnum_Type, static_cast<int>(val));
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkNIFTIHeader_UnitsXYZTEnum_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkNIFTIHeader.UnitsXYZTEnum", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkNIFTIHeader_UnitsXYZTEnum_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkNIFTIHeader_UnitsXYZTEnum_Type, static_cast<int>(val));
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkNIFTIHeader_DataTypeEnum_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkNIFTIHeader.DataTypeEnum", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkNIFTIHeader_DataTypeEnum_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkNIFTIHeader_DataTypeEnum_Type, static_cast<int>(val));
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkNIFTIHeader_HeaderSizeEnum_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkNIFTIHeader.HeaderSizeEnum", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkNIFTIHeader_HeaderSizeEnum_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkNIFTIHeader_HeaderSizeEnum_Type, static_cast<int>(val));
}


static PyObject *
PyvtkNIFTIHeader_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkNIFTIHeader::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkNIFTIHeader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkNIFTIHeader *tempr = vtkNIFTIHeader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkNIFTIHeader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkNIFTIHeader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkNIFTIHeader::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkNIFTIHeader::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetMagic(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMagic");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetMagic() :
      op->vtkNIFTIHeader::GetMagic());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetVoxOffset(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVoxOffset");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetVoxOffset() :
      op->vtkNIFTIHeader::GetVoxOffset());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetDataType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDataType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetDataType() :
      op->vtkNIFTIHeader::GetDataType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetBitPix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBitPix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetBitPix() :
      op->vtkNIFTIHeader::GetBitPix());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetDim(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDim");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetDim(temp0) :
      op->vtkNIFTIHeader::GetDim(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetPixDim(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPixDim");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double tempr = (ap.IsBound() ?
      op->GetPixDim(temp0) :
      op->vtkNIFTIHeader::GetPixDim(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetIntentCode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIntentCode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIntentCode(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetIntentCode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetIntentCode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIntentCode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetIntentCode() :
      op->vtkNIFTIHeader::GetIntentCode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetIntentName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIntentName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIntentName(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetIntentName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetIntentName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIntentName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetIntentName() :
      op->vtkNIFTIHeader::GetIntentName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetIntentP1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIntentP1");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIntentP1(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetIntentP1(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetIntentP1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIntentP1");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetIntentP1() :
      op->vtkNIFTIHeader::GetIntentP1());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetIntentP2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIntentP2");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIntentP2(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetIntentP2(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetIntentP2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIntentP2");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetIntentP2() :
      op->vtkNIFTIHeader::GetIntentP2());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetIntentP3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIntentP3");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIntentP3(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetIntentP3(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetIntentP3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIntentP3");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetIntentP3() :
      op->vtkNIFTIHeader::GetIntentP3());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetSclSlope(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSclSlope");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSclSlope(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetSclSlope(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetSclSlope(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSclSlope");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSclSlope() :
      op->vtkNIFTIHeader::GetSclSlope());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetSclInter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSclInter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSclInter(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetSclInter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetSclInter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSclInter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSclInter() :
      op->vtkNIFTIHeader::GetSclInter());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetCalMin(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCalMin");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCalMin(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetCalMin(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetCalMin(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCalMin");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetCalMin() :
      op->vtkNIFTIHeader::GetCalMin());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetCalMax(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCalMax");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCalMax(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetCalMax(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetCalMax(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCalMax");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetCalMax() :
      op->vtkNIFTIHeader::GetCalMax());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetSliceDuration(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSliceDuration");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSliceDuration(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetSliceDuration(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetSliceDuration(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceDuration");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSliceDuration() :
      op->vtkNIFTIHeader::GetSliceDuration());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetTOffset(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTOffset");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTOffset(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetTOffset(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetTOffset(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTOffset");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTOffset() :
      op->vtkNIFTIHeader::GetTOffset());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetSliceStart(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSliceStart");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSliceStart(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetSliceStart(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetSliceStart(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceStart");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetSliceStart() :
      op->vtkNIFTIHeader::GetSliceStart());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetSliceEnd(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSliceEnd");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSliceEnd(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetSliceEnd(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetSliceEnd(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceEnd");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetSliceEnd() :
      op->vtkNIFTIHeader::GetSliceEnd());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetSliceCode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSliceCode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSliceCode(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetSliceCode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetSliceCode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceCode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSliceCode() :
      op->vtkNIFTIHeader::GetSliceCode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetXYZTUnits(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetXYZTUnits");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetXYZTUnits(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetXYZTUnits(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetXYZTUnits(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetXYZTUnits");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetXYZTUnits() :
      op->vtkNIFTIHeader::GetXYZTUnits());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetDimInfo(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDimInfo");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDimInfo(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetDimInfo(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetDimInfo(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDimInfo");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetDimInfo() :
      op->vtkNIFTIHeader::GetDimInfo());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetDescrip(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDescrip");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDescrip(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetDescrip(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetDescrip(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDescrip");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetDescrip() :
      op->vtkNIFTIHeader::GetDescrip());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetAuxFile(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAuxFile");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAuxFile(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetAuxFile(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetAuxFile(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAuxFile");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetAuxFile() :
      op->vtkNIFTIHeader::GetAuxFile());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetQFormCode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQFormCode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetQFormCode(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetQFormCode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetQFormCode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQFormCode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetQFormCode() :
      op->vtkNIFTIHeader::GetQFormCode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetSFormCode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSFormCode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSFormCode(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetSFormCode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetSFormCode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSFormCode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSFormCode() :
      op->vtkNIFTIHeader::GetSFormCode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetQuaternB(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQuaternB");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetQuaternB(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetQuaternB(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetQuaternB(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQuaternB");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetQuaternB() :
      op->vtkNIFTIHeader::GetQuaternB());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetQuaternC(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQuaternC");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetQuaternC(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetQuaternC(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetQuaternC(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQuaternC");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetQuaternC() :
      op->vtkNIFTIHeader::GetQuaternC());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetQuaternD(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQuaternD");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetQuaternD(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetQuaternD(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetQuaternD(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQuaternD");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetQuaternD() :
      op->vtkNIFTIHeader::GetQuaternD());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetQOffsetX(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQOffsetX");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetQOffsetX(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetQOffsetX(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetQOffsetX(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQOffsetX");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetQOffsetX() :
      op->vtkNIFTIHeader::GetQOffsetX());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetQOffsetY(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQOffsetY");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetQOffsetY(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetQOffsetY(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetQOffsetY(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQOffsetY");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetQOffsetY() :
      op->vtkNIFTIHeader::GetQOffsetY());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetQOffsetZ(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQOffsetZ");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetQOffsetZ(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetQOffsetZ(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_GetQOffsetZ(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQOffsetZ");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetQOffsetZ() :
      op->vtkNIFTIHeader::GetQOffsetZ());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetSRowX_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSRowX");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    if (ap.IsBound())
    {
      op->SetSRowX(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkNIFTIHeader::SetSRowX(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkNIFTIHeader_SetSRowX_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSRowX");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  const size_t size0 = 4;
  double temp0[4];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetSRowX(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetSRowX(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkNIFTIHeader_SetSRowX(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 4:
      return PyvtkNIFTIHeader_SetSRowX_s1(self, args);
    case 1:
      return PyvtkNIFTIHeader_SetSRowX_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetSRowX");
  return nullptr;
}


static PyObject *
PyvtkNIFTIHeader_GetSRowX(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSRowX");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  size_t sizer = 4;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetSRowX() :
      op->vtkNIFTIHeader::GetSRowX());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetSRowY_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSRowY");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    if (ap.IsBound())
    {
      op->SetSRowY(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkNIFTIHeader::SetSRowY(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkNIFTIHeader_SetSRowY_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSRowY");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  const size_t size0 = 4;
  double temp0[4];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetSRowY(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetSRowY(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkNIFTIHeader_SetSRowY(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 4:
      return PyvtkNIFTIHeader_SetSRowY_s1(self, args);
    case 1:
      return PyvtkNIFTIHeader_SetSRowY_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetSRowY");
  return nullptr;
}


static PyObject *
PyvtkNIFTIHeader_GetSRowY(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSRowY");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  size_t sizer = 4;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetSRowY() :
      op->vtkNIFTIHeader::GetSRowY());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_SetSRowZ_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSRowZ");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    if (ap.IsBound())
    {
      op->SetSRowZ(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkNIFTIHeader::SetSRowZ(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkNIFTIHeader_SetSRowZ_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSRowZ");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  const size_t size0 = 4;
  double temp0[4];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetSRowZ(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::SetSRowZ(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkNIFTIHeader_SetSRowZ(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 4:
      return PyvtkNIFTIHeader_SetSRowZ_s1(self, args);
    case 1:
      return PyvtkNIFTIHeader_SetSRowZ_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetSRowZ");
  return nullptr;
}


static PyObject *
PyvtkNIFTIHeader_GetSRowZ(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSRowZ");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  size_t sizer = 4;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetSRowZ() :
      op->vtkNIFTIHeader::GetSRowZ());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Initialize();
    }
    else
    {
      op->vtkNIFTIHeader::Initialize();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNIFTIHeader_DeepCopy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DeepCopy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNIFTIHeader *op = static_cast<vtkNIFTIHeader *>(vp);

  vtkNIFTIHeader *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkNIFTIHeader"))
  {
    if (ap.IsBound())
    {
      op->DeepCopy(temp0);
    }
    else
    {
      op->vtkNIFTIHeader::DeepCopy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkNIFTIHeader_Methods[] = {
  {"IsTypeOf", PyvtkNIFTIHeader_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkNIFTIHeader_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkNIFTIHeader_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkNIFTIHeader\nC++: static vtkNIFTIHeader *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkNIFTIHeader_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkNIFTIHeader\nC++: vtkNIFTIHeader *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkNIFTIHeader_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkNIFTIHeader_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetMagic", PyvtkNIFTIHeader_GetMagic, METH_VARARGS,
   "GetMagic(self) -> str\nC++: const char *GetMagic()\n\nGet the magic number for the NIFTI file as a null-terminated\nstring.\n"},
  {"GetVoxOffset", PyvtkNIFTIHeader_GetVoxOffset, METH_VARARGS,
   "GetVoxOffset(self) -> int\nC++: vtkTypeInt64 GetVoxOffset()\n\nGet the offset to the pixel data within the file.\n"},
  {"GetDataType", PyvtkNIFTIHeader_GetDataType, METH_VARARGS,
   "GetDataType(self) -> int\nC++: int GetDataType()\n\nGet the data type.\n"},
  {"GetBitPix", PyvtkNIFTIHeader_GetBitPix, METH_VARARGS,
   "GetBitPix(self) -> int\nC++: int GetBitPix()\n\nGet the number of bits per pixel.\n"},
  {"GetDim", PyvtkNIFTIHeader_GetDim, METH_VARARGS,
   "GetDim(self, i:int) -> int\nC++: vtkTypeInt64 GetDim(int i)\n\nGet the nth dimension of the data, where 1 is first dimension.\n\nGetDim(0) returns the number of dimensions that are defined for\nthe file.\n"},
  {"GetPixDim", PyvtkNIFTIHeader_GetPixDim, METH_VARARGS,
   "GetPixDim(self, i:int) -> float\nC++: double GetPixDim(int i)\n\nGet the sample spacing in the nth dimension, 1 is first\ndimension.\n\nIf GetPixDim(0) is negative, then the quaternion for the qform\ndescribes the correct orientation only after the slice ordering\nhas been reversed.\n"},
  {"SetIntentCode", PyvtkNIFTIHeader_SetIntentCode, METH_VARARGS,
   "SetIntentCode(self, _arg:int) -> None\nC++: virtual void SetIntentCode(int _arg)\n\nGet the NIFTI intent code.\n\nThis is an enumerated value in the NIFTI header that states what\nthe data is intended to be used for.\n"},
  {"GetIntentCode", PyvtkNIFTIHeader_GetIntentCode, METH_VARARGS,
   "GetIntentCode(self) -> int\nC++: int GetIntentCode()\n\nGet the NIFTI intent code.\n\nThis is an enumerated value in the NIFTI header that states what\nthe data is intended to be used for.\n"},
  {"SetIntentName", PyvtkNIFTIHeader_SetIntentName, METH_VARARGS,
   "SetIntentName(self, name:str) -> None\nC++: void SetIntentName(const char *name)\n\nGet the intent name.  This should match the intent code.\n"},
  {"GetIntentName", PyvtkNIFTIHeader_GetIntentName, METH_VARARGS,
   "GetIntentName(self) -> str\nC++: const char *GetIntentName()\n\nGet the intent name.  This should match the intent code.\n"},
  {"SetIntentP1", PyvtkNIFTIHeader_SetIntentP1, METH_VARARGS,
   "SetIntentP1(self, _arg:float) -> None\nC++: virtual void SetIntentP1(double _arg)\n\nGet one of the NIFTI intent parameters.\n\nThe definition of these parameters varies according to the\nIntentCode.\n"},
  {"GetIntentP1", PyvtkNIFTIHeader_GetIntentP1, METH_VARARGS,
   "GetIntentP1(self) -> float\nC++: double GetIntentP1()\n\nGet one of the NIFTI intent parameters.\n\nThe definition of these parameters varies according to the\nIntentCode.\n"},
  {"SetIntentP2", PyvtkNIFTIHeader_SetIntentP2, METH_VARARGS,
   "SetIntentP2(self, _arg:float) -> None\nC++: virtual void SetIntentP2(double _arg)\n\nGet one of the NIFTI intent parameters.\n\nThe definition of these parameters varies according to the\nIntentCode.\n"},
  {"GetIntentP2", PyvtkNIFTIHeader_GetIntentP2, METH_VARARGS,
   "GetIntentP2(self) -> float\nC++: double GetIntentP2()\n\nGet one of the NIFTI intent parameters.\n\nThe definition of these parameters varies according to the\nIntentCode.\n"},
  {"SetIntentP3", PyvtkNIFTIHeader_SetIntentP3, METH_VARARGS,
   "SetIntentP3(self, _arg:float) -> None\nC++: virtual void SetIntentP3(double _arg)\n\nGet one of the NIFTI intent parameters.\n\nThe definition of these parameters varies according to the\nIntentCode.\n"},
  {"GetIntentP3", PyvtkNIFTIHeader_GetIntentP3, METH_VARARGS,
   "GetIntentP3(self) -> float\nC++: double GetIntentP3()\n\nGet one of the NIFTI intent parameters.\n\nThe definition of these parameters varies according to the\nIntentCode.\n"},
  {"SetSclSlope", PyvtkNIFTIHeader_SetSclSlope, METH_VARARGS,
   "SetSclSlope(self, _arg:float) -> None\nC++: virtual void SetSclSlope(double _arg)\n\nGet the scale and slope to apply to get real-valued data.\n"},
  {"GetSclSlope", PyvtkNIFTIHeader_GetSclSlope, METH_VARARGS,
   "GetSclSlope(self) -> float\nC++: double GetSclSlope()\n\nGet the scale and slope to apply to get real-valued data.\n"},
  {"SetSclInter", PyvtkNIFTIHeader_SetSclInter, METH_VARARGS,
   "SetSclInter(self, _arg:float) -> None\nC++: virtual void SetSclInter(double _arg)\n\nGet the scale and slope to apply to get real-valued data.\n"},
  {"GetSclInter", PyvtkNIFTIHeader_GetSclInter, METH_VARARGS,
   "GetSclInter(self) -> float\nC++: double GetSclInter()\n\nGet the scale and slope to apply to get real-valued data.\n"},
  {"SetCalMin", PyvtkNIFTIHeader_SetCalMin, METH_VARARGS,
   "SetCalMin(self, _arg:float) -> None\nC++: virtual void SetCalMin(double _arg)\n\nGet the calibrated range (cal_min, cal_max) of the data.\n"},
  {"GetCalMin", PyvtkNIFTIHeader_GetCalMin, METH_VARARGS,
   "GetCalMin(self) -> float\nC++: double GetCalMin()\n\nGet the calibrated range (cal_min, cal_max) of the data.\n"},
  {"SetCalMax", PyvtkNIFTIHeader_SetCalMax, METH_VARARGS,
   "SetCalMax(self, _arg:float) -> None\nC++: virtual void SetCalMax(double _arg)\n\nGet the calibrated range (cal_min, cal_max) of the data.\n"},
  {"GetCalMax", PyvtkNIFTIHeader_GetCalMax, METH_VARARGS,
   "GetCalMax(self) -> float\nC++: double GetCalMax()\n\nGet the calibrated range (cal_min, cal_max) of the data.\n"},
  {"SetSliceDuration", PyvtkNIFTIHeader_SetSliceDuration, METH_VARARGS,
   "SetSliceDuration(self, _arg:float) -> None\nC++: virtual void SetSliceDuration(double _arg)\n\nGet the slice_duration and toffset from the header.\n"},
  {"GetSliceDuration", PyvtkNIFTIHeader_GetSliceDuration, METH_VARARGS,
   "GetSliceDuration(self) -> float\nC++: double GetSliceDuration()\n\nGet the slice_duration and toffset from the header.\n"},
  {"SetTOffset", PyvtkNIFTIHeader_SetTOffset, METH_VARARGS,
   "SetTOffset(self, _arg:float) -> None\nC++: virtual void SetTOffset(double _arg)\n\nGet the slice_duration and toffset from the header.\n"},
  {"GetTOffset", PyvtkNIFTIHeader_GetTOffset, METH_VARARGS,
   "GetTOffset(self) -> float\nC++: double GetTOffset()\n\nGet the slice_duration and toffset from the header.\n"},
  {"SetSliceStart", PyvtkNIFTIHeader_SetSliceStart, METH_VARARGS,
   "SetSliceStart(self, _arg:int) -> None\nC++: virtual void SetSliceStart(vtkTypeInt64 _arg)\n\nGet the slice range for the data.\n"},
  {"GetSliceStart", PyvtkNIFTIHeader_GetSliceStart, METH_VARARGS,
   "GetSliceStart(self) -> int\nC++: vtkTypeInt64 GetSliceStart()\n\nGet the slice range for the data.\n"},
  {"SetSliceEnd", PyvtkNIFTIHeader_SetSliceEnd, METH_VARARGS,
   "SetSliceEnd(self, _arg:int) -> None\nC++: virtual void SetSliceEnd(vtkTypeInt64 _arg)\n\nGet the slice range for the data.\n"},
  {"GetSliceEnd", PyvtkNIFTIHeader_GetSliceEnd, METH_VARARGS,
   "GetSliceEnd(self) -> int\nC++: vtkTypeInt64 GetSliceEnd()\n\nGet the slice range for the data.\n"},
  {"SetSliceCode", PyvtkNIFTIHeader_SetSliceCode, METH_VARARGS,
   "SetSliceCode(self, _arg:int) -> None\nC++: virtual void SetSliceCode(int _arg)\n\nGet the slice code for the data.\n"},
  {"GetSliceCode", PyvtkNIFTIHeader_GetSliceCode, METH_VARARGS,
   "GetSliceCode(self) -> int\nC++: int GetSliceCode()\n\nGet the slice code for the data.\n"},
  {"SetXYZTUnits", PyvtkNIFTIHeader_SetXYZTUnits, METH_VARARGS,
   "SetXYZTUnits(self, _arg:int) -> None\nC++: virtual void SetXYZTUnits(int _arg)\n\nGet a bitfield that describes the units for the first 4 dims.\n"},
  {"GetXYZTUnits", PyvtkNIFTIHeader_GetXYZTUnits, METH_VARARGS,
   "GetXYZTUnits(self) -> int\nC++: int GetXYZTUnits()\n\nGet a bitfield that describes the units for the first 4 dims.\n"},
  {"SetDimInfo", PyvtkNIFTIHeader_SetDimInfo, METH_VARARGS,
   "SetDimInfo(self, _arg:int) -> None\nC++: virtual void SetDimInfo(int _arg)\n\nGet a bitfield with extra information about the dimensions, it\n\nstates which dimensions are the phase encode, frequency encode,\nand slice encode dimensions for MRI acquisitions.\n"},
  {"GetDimInfo", PyvtkNIFTIHeader_GetDimInfo, METH_VARARGS,
   "GetDimInfo(self) -> int\nC++: int GetDimInfo()\n\nGet a bitfield with extra information about the dimensions, it\n\nstates which dimensions are the phase encode, frequency encode,\nand slice encode dimensions for MRI acquisitions.\n"},
  {"SetDescrip", PyvtkNIFTIHeader_SetDescrip, METH_VARARGS,
   "SetDescrip(self, descrip:str) -> None\nC++: void SetDescrip(const char *descrip)\n\nGet a null-terminated file descriptor, this usually gives the\n\nname of the software that wrote the file. It will have a maximum\nlength of 80 characters.\n"},
  {"GetDescrip", PyvtkNIFTIHeader_GetDescrip, METH_VARARGS,
   "GetDescrip(self) -> str\nC++: const char *GetDescrip()\n\nGet a null-terminated file descriptor, this usually gives the\n\nname of the software that wrote the file. It will have a maximum\nlength of 80 characters.\n"},
  {"SetAuxFile", PyvtkNIFTIHeader_SetAuxFile, METH_VARARGS,
   "SetAuxFile(self, auxfile:str) -> None\nC++: void SetAuxFile(const char *auxfile)\n\nGet an auxiliary file, e.g. a color table, that is associated\n\nwith this data.  The length of the filename must be a maximum of\n24 characters, and it will be assumed to be in the same directory\nas the NIFTI file.\n"},
  {"GetAuxFile", PyvtkNIFTIHeader_GetAuxFile, METH_VARARGS,
   "GetAuxFile(self) -> str\nC++: const char *GetAuxFile()\n\nGet an auxiliary file, e.g. a color table, that is associated\n\nwith this data.  The length of the filename must be a maximum of\n24 characters, and it will be assumed to be in the same directory\nas the NIFTI file.\n"},
  {"SetQFormCode", PyvtkNIFTIHeader_SetQFormCode, METH_VARARGS,
   "SetQFormCode(self, _arg:int) -> None\nC++: virtual void SetQFormCode(int _arg)\n\nGet the QForm or SForm code.\n"},
  {"GetQFormCode", PyvtkNIFTIHeader_GetQFormCode, METH_VARARGS,
   "GetQFormCode(self) -> int\nC++: int GetQFormCode()\n\nGet the QForm or SForm code.\n"},
  {"SetSFormCode", PyvtkNIFTIHeader_SetSFormCode, METH_VARARGS,
   "SetSFormCode(self, _arg:int) -> None\nC++: virtual void SetSFormCode(int _arg)\n\nGet the QForm or SForm code.\n"},
  {"GetSFormCode", PyvtkNIFTIHeader_GetSFormCode, METH_VARARGS,
   "GetSFormCode(self) -> int\nC++: int GetSFormCode()\n\nGet the QForm or SForm code.\n"},
  {"SetQuaternB", PyvtkNIFTIHeader_SetQuaternB, METH_VARARGS,
   "SetQuaternB(self, _arg:float) -> None\nC++: virtual void SetQuaternB(double _arg)\n\nGet information about the quaternion transformation.  Note that\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nquaternion has been set via vtkNIFTIWriter::SetQFormMatrix().\n"},
  {"GetQuaternB", PyvtkNIFTIHeader_GetQuaternB, METH_VARARGS,
   "GetQuaternB(self) -> float\nC++: double GetQuaternB()\n\nGet information about the quaternion transformation.  Note that\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nquaternion has been set via vtkNIFTIWriter::SetQFormMatrix().\n"},
  {"SetQuaternC", PyvtkNIFTIHeader_SetQuaternC, METH_VARARGS,
   "SetQuaternC(self, _arg:float) -> None\nC++: virtual void SetQuaternC(double _arg)\n\nGet information about the quaternion transformation.  Note that\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nquaternion has been set via vtkNIFTIWriter::SetQFormMatrix().\n"},
  {"GetQuaternC", PyvtkNIFTIHeader_GetQuaternC, METH_VARARGS,
   "GetQuaternC(self) -> float\nC++: double GetQuaternC()\n\nGet information about the quaternion transformation.  Note that\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nquaternion has been set via vtkNIFTIWriter::SetQFormMatrix().\n"},
  {"SetQuaternD", PyvtkNIFTIHeader_SetQuaternD, METH_VARARGS,
   "SetQuaternD(self, _arg:float) -> None\nC++: virtual void SetQuaternD(double _arg)\n\nGet information about the quaternion transformation.  Note that\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nquaternion has been set via vtkNIFTIWriter::SetQFormMatrix().\n"},
  {"GetQuaternD", PyvtkNIFTIHeader_GetQuaternD, METH_VARARGS,
   "GetQuaternD(self) -> float\nC++: double GetQuaternD()\n\nGet information about the quaternion transformation.  Note that\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nquaternion has been set via vtkNIFTIWriter::SetQFormMatrix().\n"},
  {"SetQOffsetX", PyvtkNIFTIHeader_SetQOffsetX, METH_VARARGS,
   "SetQOffsetX(self, _arg:float) -> None\nC++: virtual void SetQOffsetX(double _arg)\n\nGet information about the quaternion transformation.  Note that\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nquaternion has been set via vtkNIFTIWriter::SetQFormMatrix().\n"},
  {"GetQOffsetX", PyvtkNIFTIHeader_GetQOffsetX, METH_VARARGS,
   "GetQOffsetX(self) -> float\nC++: double GetQOffsetX()\n\nGet information about the quaternion transformation.  Note that\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nquaternion has been set via vtkNIFTIWriter::SetQFormMatrix().\n"},
  {"SetQOffsetY", PyvtkNIFTIHeader_SetQOffsetY, METH_VARARGS,
   "SetQOffsetY(self, _arg:float) -> None\nC++: virtual void SetQOffsetY(double _arg)\n\nGet information about the quaternion transformation.  Note that\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nquaternion has been set via vtkNIFTIWriter::SetQFormMatrix().\n"},
  {"GetQOffsetY", PyvtkNIFTIHeader_GetQOffsetY, METH_VARARGS,
   "GetQOffsetY(self) -> float\nC++: double GetQOffsetY()\n\nGet information about the quaternion transformation.  Note that\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nquaternion has been set via vtkNIFTIWriter::SetQFormMatrix().\n"},
  {"SetQOffsetZ", PyvtkNIFTIHeader_SetQOffsetZ, METH_VARARGS,
   "SetQOffsetZ(self, _arg:float) -> None\nC++: virtual void SetQOffsetZ(double _arg)\n\nGet information about the quaternion transformation.  Note that\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nquaternion has been set via vtkNIFTIWriter::SetQFormMatrix().\n"},
  {"GetQOffsetZ", PyvtkNIFTIHeader_GetQOffsetZ, METH_VARARGS,
   "GetQOffsetZ(self) -> float\nC++: double GetQOffsetZ()\n\nGet information about the quaternion transformation.  Note that\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nquaternion has been set via vtkNIFTIWriter::SetQFormMatrix().\n"},
  {"SetSRowX", PyvtkNIFTIHeader_SetSRowX, METH_VARARGS,
   "SetSRowX(self, _arg1:float, _arg2:float, _arg3:float, _arg4:float)\n     -> None\nC++: virtual void SetSRowX(double _arg1, double _arg2,\n    double _arg3, double _arg4)\nSetSRowX(self, _arg:(float, float, float, float)) -> None\nC++: virtual void SetSRowX(const double _arg[4])\n\nGet information about the matrix transformation.\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nmatrix has been set via vtkNIFTIWriter::SetSFormMatrix().\n"},
  {"GetSRowX", PyvtkNIFTIHeader_GetSRowX, METH_VARARGS,
   "GetSRowX(self) -> (float, float, float, float)\nC++: virtual double *GetSRowX()\n\nGet information about the matrix transformation.\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nmatrix has been set via vtkNIFTIWriter::SetSFormMatrix().\n"},
  {"SetSRowY", PyvtkNIFTIHeader_SetSRowY, METH_VARARGS,
   "SetSRowY(self, _arg1:float, _arg2:float, _arg3:float, _arg4:float)\n     -> None\nC++: virtual void SetSRowY(double _arg1, double _arg2,\n    double _arg3, double _arg4)\nSetSRowY(self, _arg:(float, float, float, float)) -> None\nC++: virtual void SetSRowY(const double _arg[4])\n\nGet information about the matrix transformation.\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nmatrix has been set via vtkNIFTIWriter::SetSFormMatrix().\n"},
  {"GetSRowY", PyvtkNIFTIHeader_GetSRowY, METH_VARARGS,
   "GetSRowY(self) -> (float, float, float, float)\nC++: virtual double *GetSRowY()\n\nGet information about the matrix transformation.\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nmatrix has been set via vtkNIFTIWriter::SetSFormMatrix().\n"},
  {"SetSRowZ", PyvtkNIFTIHeader_SetSRowZ, METH_VARARGS,
   "SetSRowZ(self, _arg1:float, _arg2:float, _arg3:float, _arg4:float)\n     -> None\nC++: virtual void SetSRowZ(double _arg1, double _arg2,\n    double _arg3, double _arg4)\nSetSRowZ(self, _arg:(float, float, float, float)) -> None\nC++: virtual void SetSRowZ(const double _arg[4])\n\nGet information about the matrix transformation.\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nmatrix has been set via vtkNIFTIWriter::SetSFormMatrix().\n"},
  {"GetSRowZ", PyvtkNIFTIHeader_GetSRowZ, METH_VARARGS,
   "GetSRowZ(self) -> (float, float, float, float)\nC++: virtual double *GetSRowZ()\n\nGet information about the matrix transformation.\n\nNote that the vtkNIFTIWriter ignores this part of the header if a\nmatrix has been set via vtkNIFTIWriter::SetSFormMatrix().\n"},
  {"Initialize", PyvtkNIFTIHeader_Initialize, METH_VARARGS,
   "Initialize(self) -> None\nC++: void Initialize()\n\nInitialize the header to default values.\n"},
  {"DeepCopy", PyvtkNIFTIHeader_DeepCopy, METH_VARARGS,
   "DeepCopy(self, o:vtkNIFTIHeader) -> None\nC++: void DeepCopy(vtkNIFTIHeader *o)\n\nMake a copy of the header.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkNIFTIHeader_Doc =
  "vtkNIFTIHeader - Store NIfTI header information.\n\n"
  "Superclass: vtkObject\n\n"
  "This class stores the header of a NIfTI file in a VTK-friendly\n"
  "format. By using this class, it is possible to specify the header\n"
  "information that will be stored in a file written by the\n"
  "vtkNIFTIWriter.  Note that the SForm and QForm orientation\n"
  "information in this class will be ignored by the writer if an SForm\n"
  "and QForm have been explicitly set via the writer's SetSForm and\n"
  "SetQForm methods.  Also note that all info like Dim, PixDim,\n"
  "DataType, etc. will be ignored by the writer because this information\n"
  "must instead be taken from the vtkImageData information.  Finally,\n"
  "note that the vtkNIFTIWriter will ignore the Descrip field, since it\n"
  "has its own SetDescription method.\n\n"
  "This class was contributed to VTK by the Calgary Image Processing and\n"
  "Analysis Centre (CIPAC).\n\n"
  "\\sa vtkNIFTIReader, vtkNIFTIWriter\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkNIFTIHeader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkNIFTIHeader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkNIFTIHeader_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkNIFTIHeader_StaticNew()
{
  return vtkNIFTIHeader::New();
}

PyObject *PyvtkNIFTIHeader_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkNIFTIHeader_Type, PyvtkNIFTIHeader_Methods,
    "vtkNIFTIHeader",
 &PyvtkNIFTIHeader_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkObject");

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkNIFTIHeader_IntentCodeEnum_Type);
  PyVTKEnum_Add(&PyvtkNIFTIHeader_IntentCodeEnum_Type, "vtkNIFTIHeader.IntentCodeEnum");

  o = (PyObject *)&PyvtkNIFTIHeader_IntentCodeEnum_Type;
  if (PyDict_SetItemString(d, "IntentCodeEnum", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkNIFTIHeader_XFormCodeEnum_Type);
  PyVTKEnum_Add(&PyvtkNIFTIHeader_XFormCodeEnum_Type, "vtkNIFTIHeader.XFormCodeEnum");

  o = (PyObject *)&PyvtkNIFTIHeader_XFormCodeEnum_Type;
  if (PyDict_SetItemString(d, "XFormCodeEnum", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkNIFTIHeader_SliceCodeEnum_Type);
  PyVTKEnum_Add(&PyvtkNIFTIHeader_SliceCodeEnum_Type, "vtkNIFTIHeader.SliceCodeEnum");

  o = (PyObject *)&PyvtkNIFTIHeader_SliceCodeEnum_Type;
  if (PyDict_SetItemString(d, "SliceCodeEnum", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkNIFTIHeader_UnitsXYZTEnum_Type);
  PyVTKEnum_Add(&PyvtkNIFTIHeader_UnitsXYZTEnum_Type, "vtkNIFTIHeader.UnitsXYZTEnum");

  o = (PyObject *)&PyvtkNIFTIHeader_UnitsXYZTEnum_Type;
  if (PyDict_SetItemString(d, "UnitsXYZTEnum", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkNIFTIHeader_DataTypeEnum_Type);
  PyVTKEnum_Add(&PyvtkNIFTIHeader_DataTypeEnum_Type, "vtkNIFTIHeader.DataTypeEnum");

  o = (PyObject *)&PyvtkNIFTIHeader_DataTypeEnum_Type;
  if (PyDict_SetItemString(d, "DataTypeEnum", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkNIFTIHeader_HeaderSizeEnum_Type);
  PyVTKEnum_Add(&PyvtkNIFTIHeader_HeaderSizeEnum_Type, "vtkNIFTIHeader.HeaderSizeEnum");

  o = (PyObject *)&PyvtkNIFTIHeader_HeaderSizeEnum_Type;
  if (PyDict_SetItemString(d, "HeaderSizeEnum", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 40; c++)
  {
    typedef vtkNIFTIHeader::IntentCodeEnum cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[40] = {
        { "IntentNone", vtkNIFTIHeader::IntentNone },
        { "IntentCorrel", vtkNIFTIHeader::IntentCorrel },
        { "IntentTTest", vtkNIFTIHeader::IntentTTest },
        { "IntentFTest", vtkNIFTIHeader::IntentFTest },
        { "IntentZScore", vtkNIFTIHeader::IntentZScore },
        { "IntentChiSQ", vtkNIFTIHeader::IntentChiSQ },
        { "IntentBeta", vtkNIFTIHeader::IntentBeta },
        { "IntentBinom", vtkNIFTIHeader::IntentBinom },
        { "IntentGamma", vtkNIFTIHeader::IntentGamma },
        { "IntentPoisson", vtkNIFTIHeader::IntentPoisson },
        { "IntentNormal", vtkNIFTIHeader::IntentNormal },
        { "IntentFTestNonc", vtkNIFTIHeader::IntentFTestNonc },
        { "IntentChiSQNonc", vtkNIFTIHeader::IntentChiSQNonc },
        { "IntentLogistic", vtkNIFTIHeader::IntentLogistic },
        { "IntentLaplace", vtkNIFTIHeader::IntentLaplace },
        { "IntentUniform", vtkNIFTIHeader::IntentUniform },
        { "IntentTTestNonc", vtkNIFTIHeader::IntentTTestNonc },
        { "IntentWeibull", vtkNIFTIHeader::IntentWeibull },
        { "IntentChi", vtkNIFTIHeader::IntentChi },
        { "IntentInvGauss", vtkNIFTIHeader::IntentInvGauss },
        { "IntentExtVal", vtkNIFTIHeader::IntentExtVal },
        { "IntentPVal", vtkNIFTIHeader::IntentPVal },
        { "IntentLogPVal", vtkNIFTIHeader::IntentLogPVal },
        { "IntentLog10PVal", vtkNIFTIHeader::IntentLog10PVal },
        { "IntentEstimate", vtkNIFTIHeader::IntentEstimate },
        { "IntentLabel", vtkNIFTIHeader::IntentLabel },
        { "IntentNeuroName", vtkNIFTIHeader::IntentNeuroName },
        { "IntentGenMatrix", vtkNIFTIHeader::IntentGenMatrix },
        { "IntentSymMatrix", vtkNIFTIHeader::IntentSymMatrix },
        { "IntentDispVect", vtkNIFTIHeader::IntentDispVect },
        { "IntentVector", vtkNIFTIHeader::IntentVector },
        { "IntentPointSet", vtkNIFTIHeader::IntentPointSet },
        { "IntentTriangle", vtkNIFTIHeader::IntentTriangle },
        { "IntentQuaternion", vtkNIFTIHeader::IntentQuaternion },
        { "IntentDimless", vtkNIFTIHeader::IntentDimless },
        { "IntentTimeSeries", vtkNIFTIHeader::IntentTimeSeries },
        { "IntentNodeIndex", vtkNIFTIHeader::IntentNodeIndex },
        { "IntentRGBVector", vtkNIFTIHeader::IntentRGBVector },
        { "IntentRGBAVector", vtkNIFTIHeader::IntentRGBAVector },
        { "IntentShape", vtkNIFTIHeader::IntentShape },
      };

    o = PyvtkNIFTIHeader_IntentCodeEnum_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 6; c++)
  {
    typedef vtkNIFTIHeader::XFormCodeEnum cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[6] = {
        { "XFormUnkown", vtkNIFTIHeader::XFormUnkown },
        { "XFormScannerAnat", vtkNIFTIHeader::XFormScannerAnat },
        { "XFormAlignedAnat", vtkNIFTIHeader::XFormAlignedAnat },
        { "XFormTalairach", vtkNIFTIHeader::XFormTalairach },
        { "XFormMNI152", vtkNIFTIHeader::XFormMNI152 },
        { "XFormTemplateOther", vtkNIFTIHeader::XFormTemplateOther },
      };

    o = PyvtkNIFTIHeader_XFormCodeEnum_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 7; c++)
  {
    typedef vtkNIFTIHeader::SliceCodeEnum cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[7] = {
        { "SliceUnknown", vtkNIFTIHeader::SliceUnknown },
        { "SliceSeqInc", vtkNIFTIHeader::SliceSeqInc },
        { "SliceSeqDec", vtkNIFTIHeader::SliceSeqDec },
        { "SliceAltInc", vtkNIFTIHeader::SliceAltInc },
        { "SliceAltDec", vtkNIFTIHeader::SliceAltDec },
        { "SliceAltInc2", vtkNIFTIHeader::SliceAltInc2 },
        { "SliceAltDec2", vtkNIFTIHeader::SliceAltDec2 },
      };

    o = PyvtkNIFTIHeader_SliceCodeEnum_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 12; c++)
  {
    typedef vtkNIFTIHeader::UnitsXYZTEnum cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[12] = {
        { "UnitsUnknown", vtkNIFTIHeader::UnitsUnknown },
        { "UnitsMeter", vtkNIFTIHeader::UnitsMeter },
        { "UnitsMM", vtkNIFTIHeader::UnitsMM },
        { "UnitsMicron", vtkNIFTIHeader::UnitsMicron },
        { "UnitsSpace", vtkNIFTIHeader::UnitsSpace },
        { "UnitsSec", vtkNIFTIHeader::UnitsSec },
        { "UnitsMSec", vtkNIFTIHeader::UnitsMSec },
        { "UnitsUSec", vtkNIFTIHeader::UnitsUSec },
        { "UnitsHz", vtkNIFTIHeader::UnitsHz },
        { "UnitsPPM", vtkNIFTIHeader::UnitsPPM },
        { "UnitsRads", vtkNIFTIHeader::UnitsRads },
        { "UnitsTime", vtkNIFTIHeader::UnitsTime },
      };

    o = PyvtkNIFTIHeader_UnitsXYZTEnum_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 16; c++)
  {
    typedef vtkNIFTIHeader::DataTypeEnum cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[16] = {
        { "TypeUInt8", vtkNIFTIHeader::TypeUInt8 },
        { "TypeInt16", vtkNIFTIHeader::TypeInt16 },
        { "TypeInt32", vtkNIFTIHeader::TypeInt32 },
        { "TypeFloat32", vtkNIFTIHeader::TypeFloat32 },
        { "TypeComplex64", vtkNIFTIHeader::TypeComplex64 },
        { "TypeFloat64", vtkNIFTIHeader::TypeFloat64 },
        { "TypeRGB24", vtkNIFTIHeader::TypeRGB24 },
        { "TypeInt8", vtkNIFTIHeader::TypeInt8 },
        { "TypeUInt16", vtkNIFTIHeader::TypeUInt16 },
        { "TypeUInt32", vtkNIFTIHeader::TypeUInt32 },
        { "TypeInt64", vtkNIFTIHeader::TypeInt64 },
        { "TypeUInt64", vtkNIFTIHeader::TypeUInt64 },
        { "TypeFloat128", vtkNIFTIHeader::TypeFloat128 },
        { "TypeComplex128", vtkNIFTIHeader::TypeComplex128 },
        { "TypeComplex256", vtkNIFTIHeader::TypeComplex256 },
        { "TypeRGBA32", vtkNIFTIHeader::TypeRGBA32 },
      };

    o = PyvtkNIFTIHeader_DataTypeEnum_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 2; c++)
  {
    typedef vtkNIFTIHeader::HeaderSizeEnum cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[2] = {
        { "Nifti1HeaderSize", vtkNIFTIHeader::Nifti1HeaderSize },
        { "Nifti2HeaderSize", vtkNIFTIHeader::Nifti2HeaderSize },
      };

    o = PyvtkNIFTIHeader_HeaderSizeEnum_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkNIFTIHeader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkNIFTIHeader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkNIFTIHeader", o) != 0)
  {
    Py_DECREF(o);
  }

}

